diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-find-external-library.cmake ns-3.41/build-support/custom-modules/ns3-find-external-library.cmake
--- ns-3.40/build-support/custom-modules/ns3-find-external-library.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-find-external-library.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,339 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# This is our own variant of find_package, for CMake and non-CMake based
+# projects
+function(log_find_searched_paths)
+  # Parse arguments
+  set(options)
+  set(oneValueArgs TARGET_TYPE TARGET_NAME SEARCH_RESULT SEARCH_SYSTEM_PREFIX)
+  set(multiValueArgs SEARCH_PATHS SEARCH_SUFFIXES)
+  cmake_parse_arguments(
+    "LOGFIND" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
+  )
+
+  # Get searched paths and add cmake_system_prefix_path if not explicitly marked
+  # not to include it
+  set(tsearch_paths ${LOGFIND_SEARCH_PATHS})
+  if("${LOGFIND_SEARCH_SYSTEM_PREFIX}" STREQUAL "")
+    list(APPEND tsearch_paths "${CMAKE_SYSTEM_PREFIX_PATH}")
+  endif()
+
+  set(log_find
+      "Looking for ${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} in:\n"
+  )
+  # For each search path and suffix combination, print a line
+  foreach(tsearch_path ${tsearch_paths})
+    foreach(suffix ${LOGFIND_SEARCH_SUFFIXES})
+      string(APPEND log_find
+             "\t${tsearch_path}${suffix}/${LOGFIND_TARGET_NAME}\n"
+      )
+    endforeach()
+  endforeach()
+
+  # Add a final line saying if the file was found and where, or if it was not
+  # found
+  if("${${LOGFIND_SEARCH_RESULT}}" STREQUAL "${LOGFIND_SEARCH_RESULT}-NOTFOUND")
+    string(APPEND log_find
+           "\n\t${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} was not found\n"
+    )
+  else()
+    string(
+      APPEND
+      log_find
+      "\n\t${LOGFIND_TARGET_TYPE} ${LOGFIND_TARGET_NAME} was found in ${${LOGFIND_SEARCH_RESULT}}\n"
+    )
+  endif()
+
+  # Replace duplicate path separators
+  string(REPLACE "//" "/" log_find "${log_find}")
+
+  # Print find debug message similar to the one produced by
+  # CMAKE_FIND_DEBUG_MODE=true in CMake >= 3.17
+  message(STATUS ${log_find})
+endfunction()
+
+function(find_external_library)
+  # Parse arguments
+  set(options QUIET)
+  set(oneValueArgs DEPENDENCY_NAME HEADER_NAME LIBRARY_NAME OUTPUT_VARIABLE)
+  set(multiValueArgs HEADER_NAMES LIBRARY_NAMES PATH_SUFFIXES SEARCH_PATHS)
+  cmake_parse_arguments(
+    "FIND_LIB" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN}
+  )
+
+  # Set the external package/dependency name
+  set(name ${FIND_LIB_DEPENDENCY_NAME})
+
+  # We process individual and list of headers and libraries by transforming them
+  # into lists
+  set(library_names "${FIND_LIB_LIBRARY_NAME};${FIND_LIB_LIBRARY_NAMES}")
+  set(header_names "${FIND_LIB_HEADER_NAME};${FIND_LIB_HEADER_NAMES}")
+
+  # Just changing the parsed argument name back to something shorter
+  set(search_paths ${FIND_LIB_SEARCH_PATHS})
+  set(path_suffixes "${FIND_LIB_PATH_SUFFIXES}")
+
+  set(not_found_libraries)
+  set(library_dirs)
+  set(libraries)
+
+  # Include parent directories in the search paths to handle Bake cases
+  get_filename_component(parent_project_dir ${PROJECT_SOURCE_DIR} DIRECTORY)
+  get_filename_component(
+    grandparent_project_dir ${parent_project_dir} DIRECTORY
+  )
+  set(project_parent_dirs ${parent_project_dir} ${grandparent_project_dir})
+
+  # Paths and suffixes where libraries will be searched on
+  disable_cmake_warnings()
+  set(library_search_paths
+      ${search_paths}
+      ${project_parent_dirs}
+      ${CMAKE_OUTPUT_DIRECTORY} # Search for libraries in ns-3-dev/build
+      ${CMAKE_INSTALL_PREFIX} # Search for libraries in the install directory
+      # (e.g. /usr/)
+      $ENV{LD_LIBRARY_PATH} # Search for libraries in LD_LIBRARY_PATH
+      # directories
+      $ENV{PATH} # Search for libraries in PATH directories
+  )
+  enable_cmake_warnings()
+  # cmake-format: off
+    #
+    # Split : separated entries from environment variables
+    # by replacing separators with ;
+    #
+    # cmake-format: on
+  string(REPLACE ":" ";" library_search_paths "${library_search_paths}")
+
+  set(suffixes /build /lib /build/lib / /bin ${path_suffixes})
+
+  # For each of the library names in LIBRARY_NAMES or LIBRARY_NAME
+  foreach(library ${library_names})
+    # We mark this value is advanced not to pollute the configuration with
+    # ccmake with the cache variables used internally
+    mark_as_advanced(${name}_library_internal_${library})
+
+    # We search for the library named ${library} and store the results in
+    # ${name}_library_internal_${library}
+    find_library(
+      ${name}_library_internal_${library} ${library}
+      HINTS ${library_search_paths} PATH_SUFFIXES ${suffixes}
+    )
+    # cmake-format: off
+        # Note: the PATH_SUFFIXES above apply to *ALL* PATHS and HINTS Which
+        # translates to CMake searching on standard library directories
+        # CMAKE_SYSTEM_PREFIX_PATH, user-settable CMAKE_PREFIX_PATH or
+        # CMAKE_LIBRARY_PATH and the directories listed above
+        #
+        # e.g.  from Ubuntu 22.04 CMAKE_SYSTEM_PREFIX_PATH =
+        # /usr/local;/usr;/;/usr/local;/usr/X11R6;/usr/pkg;/opt
+        #
+        # Searched directories without suffixes
+        #
+        # ${CMAKE_SYSTEM_PREFIX_PATH}[0] = /usr/local/
+        # ${CMAKE_SYSTEM_PREFIX_PATH}[1] = /usr
+        # ${CMAKE_SYSTEM_PREFIX_PATH}[2] = /
+        # ...
+        # ${CMAKE_SYSTEM_PREFIX_PATH}[6] = /opt
+        # ${LD_LIBRARY_PATH}[0]
+        # ...
+        # ${LD_LIBRARY_PATH}[m]
+        # ${PATH}[0]
+        # ...
+        # ${PATH}[m]
+        #
+        # Searched directories with suffixes include all of the directories above
+        # plus all suffixes
+        # PATH_SUFFIXES /build /lib /build/lib / /bin # ${path_suffixes}
+        #
+        # /usr/local/build
+        # /usr/local/lib
+        # /usr/local/build/lib
+        # /usr/local/bin
+        # ...
+        #
+        # cmake-format: on
+    # Or enable NS3_VERBOSE to print the searched paths
+
+    # Print tested paths to the searched library and if it was found
+    if(${NS3_VERBOSE} AND (${CMAKE_VERSION} VERSION_LESS "3.17.0"))
+      log_find_searched_paths(
+        TARGET_TYPE
+        Library
+        TARGET_NAME
+        ${library}
+        SEARCH_RESULT
+        ${name}_library_internal_${library}
+        SEARCH_PATHS
+        ${library_search_paths}
+        SEARCH_SUFFIXES
+        ${suffixes}
+      )
+    endif()
+
+    # After searching the library, the internal variable should have either the
+    # absolute path to the library or the name of the variable appended with
+    # -NOTFOUND
+    if("${${name}_library_internal_${library}}" STREQUAL
+       "${name}_library_internal_${library}-NOTFOUND"
+    )
+      # We keep track of libraries that were not found
+      list(APPEND not_found_libraries ${library})
+    else()
+      # We get the name of the parent directory of the library and append the
+      # library to a list of found libraries
+      get_filename_component(
+        ${name}_library_dir_internal ${${name}_library_internal_${library}}
+        DIRECTORY
+      ) # e.g. lib/openflow.(so|dll|dylib|a) -> lib
+      list(APPEND library_dirs ${${name}_library_dir_internal})
+      list(APPEND libraries ${${name}_library_internal_${library}})
+    endif()
+  endforeach()
+
+  # For each library that was found (e.g. /usr/lib/pthread.so), get their parent
+  # directory (/usr/lib) and its parent (/usr)
+  set(parent_dirs)
+  foreach(libdir ${library_dirs})
+    get_filename_component(parent_libdir ${libdir} DIRECTORY)
+    get_filename_component(parent_parent_libdir ${parent_libdir} DIRECTORY)
+    list(APPEND parent_dirs ${libdir} ${parent_libdir} ${parent_parent_libdir})
+  endforeach()
+
+  set(header_search_paths
+      ${search_paths}
+      ${parent_dirs}
+      ${project_parent_dirs}
+      ${CMAKE_OUTPUT_DIRECTORY} # Search for headers in
+      # ns-3-dev/build
+      ${CMAKE_INSTALL_PREFIX} # Search for headers in the install
+  )
+
+  set(not_found_headers)
+  set(include_dirs)
+  foreach(header ${header_names})
+    # The same way with libraries, we mark the internal variable as advanced not
+    # to pollute ccmake configuration with variables used internally
+    mark_as_advanced(${name}_header_internal_${header})
+    set(suffixes
+        /build
+        /include
+        /build/include
+        /build/include/${name}
+        /include/${name}
+        /${name}
+        /
+        ${path_suffixes}
+    )
+
+    # cmake-format: off
+        # Here we search for the header file named ${header} and store the result in
+        # ${name}_header_internal_${header}
+        #
+        # The same way we did with libraries, here we search on
+        # CMAKE_SYSTEM_PREFIX_PATH, along with user-settable ${search_paths}, the
+        # parent directories from the libraries, CMAKE_OUTPUT_DIRECTORY and
+        # CMAKE_INSTALL_PREFIX
+        #
+        # And again, for each of them, for every suffix listed /usr/local/build
+        # /usr/local/include
+        # /usr/local/build/include
+        # /usr/local/build/include/${name}
+        # /usr/local/include/${name}
+        # ...
+        #
+        # cmake-format: on
+    # Or enable NS3_VERBOSE to get the searched paths printed while configuring
+
+    find_file(${name}_header_internal_${header} ${header}
+              HINTS ${header_search_paths} # directory (e.g. /usr/)
+              PATH_SUFFIXES ${suffixes}
+    )
+
+    # Print tested paths to the searched header and if it was found
+    if(${NS3_VERBOSE} AND (${CMAKE_VERSION} VERSION_LESS "3.17.0"))
+      log_find_searched_paths(
+        TARGET_TYPE
+        Header
+        TARGET_NAME
+        ${header}
+        SEARCH_RESULT
+        ${name}_header_internal_${header}
+        SEARCH_PATHS
+        ${header_search_paths}
+        SEARCH_SUFFIXES
+        ${suffixes}
+      )
+    endif()
+
+    # If the header file was not found, append to the not-found list
+    if("${${name}_header_internal_${header}}" STREQUAL
+       "${name}_header_internal_${header}-NOTFOUND"
+    )
+      list(APPEND not_found_headers ${header})
+    else()
+      # If the header file was found, get their directories and the parent of
+      # their directories to add as include directories
+      get_filename_component(
+        header_include_dir ${${name}_header_internal_${header}} DIRECTORY
+      ) # e.g. include/click/ (simclick.h) -> #include <simclick.h> should work
+      get_filename_component(
+        header_include_dir2 ${header_include_dir} DIRECTORY
+      ) # e.g. include/(click) -> #include <click/simclick.h> should work
+      list(APPEND include_dirs ${header_include_dir} ${header_include_dir2})
+    endif()
+  endforeach()
+
+  # Remove duplicate include directories
+  if(include_dirs)
+    list(REMOVE_DUPLICATES include_dirs)
+  endif()
+
+  # If we find both library and header, we export their values
+  if((NOT not_found_libraries) AND (NOT not_found_headers))
+    set(${name}_INCLUDE_DIRS "${include_dirs}" PARENT_SCOPE)
+    set(${name}_LIBRARIES "${libraries}" PARENT_SCOPE)
+    set(${name}_FOUND TRUE PARENT_SCOPE)
+    if(NOT ${FIND_LIB_QUIET})
+      message(STATUS "find_external_library: ${name} was found.")
+    endif()
+  else()
+    set(${name}_INCLUDE_DIRS PARENT_SCOPE)
+    set(${name}_LIBRARIES PARENT_SCOPE)
+    set(${name}_FOUND FALSE PARENT_SCOPE)
+
+    set(missing_components
+        "Missing headers: \"${not_found_headers}\" and missing libraries: \"${not_found_libraries}\""
+    )
+
+    # Propagate missing components to the specified variable
+    if(DEFINED FIND_LIB_OUTPUT_VARIABLE)
+      mark_as_advanced(${FIND_LIB_OUTPUT_VARIABLE})
+      set(${FIND_LIB_OUTPUT_VARIABLE} "${missing_components}" CACHE INTERNAL "")
+      return()
+    endif()
+
+    # If no variable is specified, log it instead
+    if(NOT ${FIND_LIB_QUIET})
+      message(
+        ${HIGHLIGHTED_STATUS}
+        "find_external_library: ${name} was not found. ${missing_components}."
+      )
+    endif()
+  endif()
+endfunction()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-hidden-settings.cmake ns-3.41/build-support/custom-modules/ns3-hidden-settings.cmake
--- ns-3.40/build-support/custom-modules/ns3-hidden-settings.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-hidden-settings.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,49 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# Set INT128 as the default option for INT64X64 and register alternative
+# implementations
+set(NS3_INT64X64 "INT128" CACHE STRING "Int64x64 implementation")
+set_property(CACHE NS3_INT64X64 PROPERTY STRINGS INT128 CAIRO DOUBLE)
+
+# Purposefully hidden options:
+
+# For ease of use, export all libraries and include directories to ns-3 module
+# consumers by default
+option(NS3_REEXPORT_THIRD_PARTY_LIBRARIES "Export all third-party libraries
+and include directories to ns-3 module consumers" ON
+)
+
+# Since we can't really do that safely from the CMake side
+option(NS3_ENABLE_SUDO
+       "Set executables ownership to root and enable the SUID flag" OFF
+)
+
+# A flag that controls some aspects related to pip packaging
+option(NS3_PIP_PACKAGING "Control aspects related to pip wheel packaging" OFF)
+
+# fPIC (position-independent code) and fPIE (position-independent executable)
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
+# Do not create a file-level dependency with shared libraries reducing
+# unnecessary relinking
+set(CMAKE_LINK_DEPENDS_NO_SHARED TRUE)
+
+# Honor CMAKE_CXX_STANDARD in check_cxx_source_compiles
+# https://cmake.org/cmake/help/latest/policy/CMP0067.html
+cmake_policy(SET CMP0066 NEW)
+cmake_policy(SET CMP0067 NEW)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-lock.cmake ns-3.41/build-support/custom-modules/ns3-lock.cmake
--- ns-3.40/build-support/custom-modules/ns3-lock.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/custom-modules/ns3-lock.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -76,7 +76,6 @@
   string(REPLACE ";" "', '" PATH_LIST "${PATH_LIST}")
   string(APPEND lock_contents "NS3_MODULE_PATH = ['${PATH_LIST}']\n")
 
-  cache_cmake_flag(ENABLE_REALTIME "ENABLE_REAL_TIME" lock_contents)
   cache_cmake_flag(ENABLE_EXAMPLES "ENABLE_EXAMPLES" lock_contents)
   cache_cmake_flag(ENABLE_TESTS "ENABLE_TESTS" lock_contents)
   cache_cmake_flag(NS3_OPENFLOW "ENABLE_OPENFLOW" lock_contents)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-module-macros.cmake ns-3.41/build-support/custom-modules/ns3-module-macros.cmake
--- ns-3.40/build-support/custom-modules/ns3-module-macros.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/custom-modules/ns3-module-macros.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -15,6 +15,80 @@
 #
 # Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
 
+add_custom_target(copy_all_headers)
+function(copy_headers_before_building_lib libname outputdir headers visibility)
+  foreach(header ${headers})
+    # Copy header to output directory on changes -> too darn slow
+    # configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${header} ${outputdir}/
+    # COPYONLY)
+
+    get_filename_component(
+      header_name ${CMAKE_CURRENT_SOURCE_DIR}/${header} NAME
+    )
+
+    # If output directory does not exist, create it
+    if(NOT (EXISTS ${outputdir}))
+      file(MAKE_DIRECTORY ${outputdir})
+    endif()
+
+    # If header already exists, skip symlinking/stub header creation
+    if(EXISTS ${outputdir}/${header_name})
+      continue()
+    endif()
+
+    # Create a stub header in the output directory, including the real header
+    # inside their respective module
+    get_filename_component(
+      ABSOLUTE_HEADER_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${header}" ABSOLUTE
+    )
+    file(WRITE ${outputdir}/${header_name}
+         "#include \"${ABSOLUTE_HEADER_PATH}\"\n"
+    )
+  endforeach()
+endfunction(copy_headers_before_building_lib)
+
+function(remove_lib_prefix prefixed_library library)
+  # Check if there is a lib prefix
+  string(FIND "${prefixed_library}" "lib" lib_pos)
+
+  # If there is a lib prefix, try to remove it
+  if(${lib_pos} EQUAL 0)
+    # Check if we still have something remaining after removing the "lib" prefix
+    string(LENGTH ${prefixed_library} len)
+    if(${len} LESS 4)
+      message(FATAL_ERROR "Invalid library name: ${prefixed_library}")
+    endif()
+
+    # Remove lib prefix from module name (e.g. libcore -> core)
+    string(SUBSTRING "${prefixed_library}" 3 -1 unprefixed_library)
+  else()
+    set(unprefixed_library ${prefixed_library})
+  endif()
+
+  # Save the unprefixed library name to the parent scope
+  set(${library} ${unprefixed_library} PARENT_SCOPE)
+endfunction()
+
+function(check_for_missing_libraries output_variable_name libraries)
+  set(missing_dependencies)
+  foreach(lib ${libraries})
+    # skip check for ns-3 modules if its a path to a library
+    if(EXISTS ${lib})
+      continue()
+    endif()
+
+    # check if the example depends on disabled modules
+    remove_lib_prefix("${lib}" lib)
+
+    # Check if the module exists in the ns-3 modules list or if it is a
+    # 3rd-party library
+    if(NOT (${lib} IN_LIST ns3-all-enabled-modules))
+      list(APPEND missing_dependencies ${lib})
+    endif()
+  endforeach()
+  set(${output_variable_name} ${missing_dependencies} PARENT_SCOPE)
+endfunction()
+
 # cmake-format: off
 #
 # This macro processes a ns-3 module
@@ -94,6 +168,7 @@
   add_library(ns3::${lib${BLIB_LIBNAME}} ALIAS ${lib${BLIB_LIBNAME}})
 
   # Associate public headers with library for installation purposes
+  set(config_headers)
   if("${BLIB_LIBNAME}" STREQUAL "core")
     set(config_headers ${CMAKE_HEADER_OUTPUT_DIRECTORY}/config-store-config.h
                        ${CMAKE_HEADER_OUTPUT_DIRECTORY}/core-config.h
@@ -104,9 +179,7 @@
       )
     endif()
 
-    if((NOT FILESYSTEM_LIBRARY_IS_LINKED) OR (${GCC} AND ${GCC8}))
-      # The GCC8 alternative is necessary since when installed alongside newer
-      # releases, the incorrect shared library can end up being linked.
+    if(NOT FILESYSTEM_LIBRARY_IS_LINKED)
       list(APPEND BLIB_LIBRARIES_TO_LINK -lstdc++fs)
     endif()
 
@@ -225,17 +298,9 @@
   )
 
   if(NOT ${XCODE})
-    # Since linking libraries to object libraries in not allowed in older CMake
-    # releases, we need to import each of their include directories. Otherwise,
-    # include directories won't be properly propagated
-    set(temp)
-    foreach(target ${ns_libraries_to_link})
-      list(APPEND temp
-           "$<TARGET_PROPERTY:${target},INTERFACE_INCLUDE_DIRECTORIES>"
-      )
-    endforeach()
-    target_include_directories(${lib${BLIB_LIBNAME}}-obj PRIVATE ${temp})
-    unset(temp)
+    target_link_libraries(
+      ${lib${BLIB_LIBNAME}}-obj PRIVATE ${ns_libraries_to_link}
+    )
   endif()
 
   # set output name of library
@@ -468,8 +533,9 @@
 
   if((NOT missing_dependencies) AND ${filtered_in})
     # Convert boolean into text to forward argument
+    set(IGNORE_PCH)
     if(${BLIB_EXAMPLE_IGNORE_PCH})
-      set(IGNORE_PCH IGNORE_PCH)
+      set(IGNORE_PCH "IGNORE_PCH")
     endif()
     # Create executable with sources and headers
     # cmake-format: off
@@ -479,7 +545,7 @@
       HEADER_FILES ${BLIB_EXAMPLE_HEADER_FILES}
       LIBRARIES_TO_LINK
         ${lib${BLIB_LIBNAME}} ${BLIB_EXAMPLE_LIBRARIES_TO_LINK}
-        ${optional_visualizer_lib}
+        ${ns3-optional-visualizer-lib}
       EXECUTABLE_DIRECTORY_PATH ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${FOLDER}/
       ${IGNORE_PCH}
     )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-ns3rc-parser.cmake ns-3.41/build-support/custom-modules/ns3-ns3rc-parser.cmake
--- ns-3.40/build-support/custom-modules/ns3-ns3rc-parser.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-ns3rc-parser.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,112 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# Parse .ns3rc
+macro(parse_ns3rc enabled_modules disabled_modules examples_enabled
+      tests_enabled
+)
+  # Try to find .ns3rc
+  disable_cmake_warnings()
+  find_file(NS3RC .ns3rc PATHS /etc $ENV{HOME} $ENV{USERPROFILE}
+                               ${PROJECT_SOURCE_DIR} NO_CACHE
+  )
+  enable_cmake_warnings()
+
+  # Set variables with default values (all modules, no examples nor tests)
+  set(${enabled_modules} "")
+  set(${disabled_modules} "")
+  set(${examples_enabled} "FALSE")
+  set(${tests_enabled} "FALSE")
+
+  if(NOT (${NS3RC} STREQUAL "NS3RC-NOTFOUND"))
+    message(${HIGHLIGHTED_STATUS}
+            "Configuration file .ns3rc being used : ${NS3RC}"
+    )
+    file(READ ${NS3RC} ns3rc_contents)
+    # Check if ns3rc file is CMake or Python based and act accordingly
+    if(ns3rc_contents MATCHES "ns3rc_*")
+      include(${NS3RC})
+    else()
+      parse_python_ns3rc(
+        "${ns3rc_contents}" ${enabled_modules} ${examples_enabled}
+        ${tests_enabled} ${NS3RC}
+      )
+    endif()
+  endif()
+endmacro(parse_ns3rc)
+
+function(parse_python_ns3rc ns3rc_contents enabled_modules examples_enabled
+         tests_enabled ns3rc_location
+)
+  # Save .ns3rc backup
+  file(WRITE ${ns3rc_location}.backup ${ns3rc_contents})
+
+  # Match modules_enabled list
+  if(ns3rc_contents MATCHES "modules_enabled.*\\[(.*).*\\]")
+    set(${enabled_modules} ${CMAKE_MATCH_1})
+    if(${enabled_modules} MATCHES "all_modules")
+      # If all modules, just clean the filter and all modules will get built by
+      # default
+      set(${enabled_modules})
+    else()
+      # If modules are listed, remove quotes and replace commas with semicolons
+      # transforming a string into a cmake list
+      string(REPLACE "," ";" ${enabled_modules} "${${enabled_modules}}")
+      string(REPLACE "'" "" ${enabled_modules} "${${enabled_modules}}")
+      string(REPLACE "\"" "" ${enabled_modules} "${${enabled_modules}}")
+      string(REPLACE " " "" ${enabled_modules} "${${enabled_modules}}")
+      string(REPLACE "\n" ";" ${enabled_modules} "${${enabled_modules}}")
+      list(SORT ${enabled_modules})
+
+      # Remove possibly empty entry
+      list(REMOVE_ITEM ${enabled_modules} "")
+      foreach(element ${${enabled_modules}})
+        # Inspect each element for comments
+        if(${element} MATCHES "#.*")
+          list(REMOVE_ITEM ${enabled_modules} ${element})
+        endif()
+      endforeach()
+    endif()
+  endif()
+
+  string(REPLACE "True" "ON" ns3rc_contents ${ns3rc_contents})
+  string(REPLACE "False" "OFF" ns3rc_contents ${ns3rc_contents})
+
+  # Match examples_enabled flag
+  if(ns3rc_contents MATCHES "examples_enabled = (ON|OFF)")
+    set(${examples_enabled} ${CMAKE_MATCH_1})
+  endif()
+
+  # Match tests_enabled flag
+  if(ns3rc_contents MATCHES "tests_enabled = (ON|OFF)")
+    set(${tests_enabled} ${CMAKE_MATCH_1})
+  endif()
+
+  # Save variables to parent scope
+  set(${enabled_modules} "${${enabled_modules}}" PARENT_SCOPE)
+  set(${examples_enabled} "${${examples_enabled}}" PARENT_SCOPE)
+  set(${tests_enabled} "${${tests_enabled}}" PARENT_SCOPE)
+
+  # Save updated .ns3rc file
+  message(
+    ${HIGHLIGHTED_STATUS}
+    "The python-based .ns3rc file format is deprecated and was updated to the CMake format"
+  )
+  configure_file(
+    ${PROJECT_SOURCE_DIR}/build-support/.ns3rc-template ${ns3rc_location} @ONLY
+  )
+endfunction(parse_python_ns3rc)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-output-directory.cmake ns-3.41/build-support/custom-modules/ns3-output-directory.cmake
--- ns-3.40/build-support/custom-modules/ns3-output-directory.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-output-directory.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,82 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# This is where we define where executables, libraries and headers will end up
+
+if("${NS3_OUTPUT_DIRECTORY}" STREQUAL "")
+  message(STATUS "Using default output directory ${PROJECT_SOURCE_DIR}/build")
+  set(CMAKE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/build) # default output
+  # folder
+else()
+  # Check if NS3_OUTPUT_DIRECTORY is a relative path
+  set(absolute_ns3_output_directory "${NS3_OUTPUT_DIRECTORY}")
+  if(NOT IS_ABSOLUTE ${NS3_OUTPUT_DIRECTORY})
+    set(absolute_ns3_output_directory
+        "${PROJECT_SOURCE_DIR}/${NS3_OUTPUT_DIRECTORY}"
+    )
+  endif()
+
+  # Transform backward slash into forward slash Not the best way to do it since
+  # \ is a scape thing and can be used before whitespaces
+  string(REPLACE "\\" "/" absolute_ns3_output_directory
+                 "${absolute_ns3_output_directory}"
+  )
+
+  if(NOT (EXISTS ${absolute_ns3_output_directory}))
+    message(
+      STATUS
+        "User-defined output directory \"${NS3_OUTPUT_DIRECTORY}\" doesn't exist. Trying to create it"
+    )
+    file(MAKE_DIRECTORY ${absolute_ns3_output_directory})
+    if(NOT (EXISTS ${absolute_ns3_output_directory}))
+      message(
+        FATAL_ERROR
+          "User-defined output directory \"${absolute_ns3_output_directory}\" could not be created. "
+          "Try changing the value of NS3_OUTPUT_DIRECTORY"
+      )
+    endif()
+
+    # If this directory is not inside the ns-3-dev folder, alert users tests may
+    # break
+    if(NOT ("${absolute_ns3_output_directory}" MATCHES "${PROJECT_SOURCE_DIR}"))
+      message(
+        WARNING
+          "User-defined output directory \"${absolute_ns3_output_directory}\" is outside "
+          " of the ns-3 directory ${PROJECT_SOURCE_DIR}, which will break some tests"
+      )
+    endif()
+  endif()
+  message(
+    STATUS
+      "User-defined output directory \"${absolute_ns3_output_directory}\" will be used"
+  )
+  set(CMAKE_OUTPUT_DIRECTORY ${absolute_ns3_output_directory})
+endif()
+
+set(libdir "lib")
+if(${CMAKE_INSTALL_LIBDIR} MATCHES "lib64")
+  set(libdir "lib64")
+endif()
+
+set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/${libdir})
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/${libdir})
+set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
+set(CMAKE_HEADER_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/include/ns3)
+set(THIRD_PARTY_DIRECTORY ${PROJECT_SOURCE_DIR}/3rd-party)
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+link_directories(${CMAKE_OUTPUT_DIRECTORY}/${libdir})
+file(MAKE_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
